close all;

//declaration of the endogenous variables
var zt ztf mc w rk mcf ld sd yd lf;
var sf yf kd kf i k l pi r c;
var re r_f pi_f pm pd py px da pid db;
var pid_star fa pix fb pix_star qx;
var qm a_f lambda eta;
var qa pim qb pim_star y;

varexo epsilonzt epsilonztf epsilona_f epsilonr_f epsilonpi_f epsilonm;    


parameters pid_ss pim_ss pix_ss pi_ss pi_f_ss zt_ss ztf_ss r_ss y_ss a_f_ss r_f_ss ;
parameters mua muy;
parameters nua nuy nux num nud;
parameters alfa betta delta xi phi;
parameters gammad gammax gammam;
parameters nua_f mua_f;
parameters rhozt rhoztf rhoa_f rhor_f rhopi_f;
parameters sigma;
parameters dd dx dm;
parameters sigmal phim phiy;

//to be estimated

parameters phipi;



// Parameter Values     
%calibration;
rhozt               = 0.89;
rhoztf              = 0.95;
rhoa_f              = 0.97;
rhor_f              = 0.99;
rhopi_f             = 0.35;
alfa                = 0.4;
xi                  = 1.2;
delta               = 0.035;
phi                 = 0;
betta               = 0.985;
sigma               = 2.1;
nua                 = 0.74;
mua                 = 3.5;
nuy                 = 0.74;     %//nuy                 = 0.75;
muy                 = 3.5;
dd                  = 0.85;
pid_ss              = 1;   %//pid_ss              = 1.04^0.25;
gammad              = 1;
nud                 = 0.1;
dx                  = 0.86;
pix_ss              = 1;   %//pix_ss              = 1.04^0.25;
gammax              = 1;
nux                 = 0.1;
dm                  = 0.83;
pim_ss              = 1;   %//pim_ss              = 1.04^0.25;
gammam              = 1; 
num                 = 0.1;
sigmal              = 6.16;
nua_f               = 0.74;
mua_f               = 3.5;
zt_ss               = 0;
ztf_ss              = 0;
phim                = 0.98;
phipi               = 1.31;
phiy                = 0.78;
r_ss                = 1 / betta;
y_ss                = 4.2832;    %//y_ss                = 60.9983;
a_f_ss              = log((1-nuy)/(1-nua_f)*(1+num)^(1+mua_f)) + y_ss;
r_f_ss              = 1 / betta;
pi_ss               = 1;
pi_f_ss             = 1;

model;
%1-2
zt = rhozt*zt(-1) + (1-rhozt)*zt_ss + epsilonzt;
ztf = rhoztf*ztf(-1) + (1-rhoztf)*ztf_ss + epsilonztf;

%3-4
exp(mc) = ( (1-alfa) * exp(w *(1-xi)) + alfa * rk^(1-xi) )^(1/(1-xi)) / exp(zt);
exp(mcf) = ((1-alfa)*exp(w)^(1-xi) + alfa*rk^(1-xi)  )^(1/(1-xi))/exp(ztf);

%5-6
sd = (1-dd)* (pid/pid_star)^( (1+nud)/nud  ) + dd*(pid/pid_ss^(1-gammad)/pid(-1)^gammad)^( (1+nud)/nud ) * sd(-1);
sf = (1-dx)* (pix/pix_star)^( (1+nux)/nux  ) + dx*(pix/pix_ss^(1-gammax)/pix(-1)^gammax)^( (1+nux)/nux ) * sf(-1);

%7-9
exp(ld) = (1-alfa)/exp(zt)* ( exp(mc) * exp(zt) / exp(w) )^xi * sd * exp(yd);
exp(lf) = (1-alfa)/exp(ztf)* ( exp(mcf) * exp(ztf) / exp(w) )^xi * sf * exp(yf);
exp(l) = exp(ld) + exp(lf);

%10
-exp(sigmal * l) + exp(lambda) * exp(w) = 0;

%11-13
%exp(kd(-1)) = alfa/exp(zt)*( exp(mc)*exp(zt)/rk )^xi * sd * exp(yd);
%exp(kf(-1)) = alfa/exp(ztf)*( exp(mcf)*exp(ztf)/rk )^xi * sf * exp(yf);
%exp(k(-1)) = exp(kd(-1)) + exp(kf(-1));
exp(kd) = alfa/exp(zt)*( exp(mc)*exp(zt)/rk )^xi * sd * exp(yd);
exp(kf) = alfa/exp(ztf)*( exp(mcf)*exp(ztf)/rk )^xi * sf * exp(yf);
exp(k) = exp(kd) + exp(kf);

%14
exp(k) = (1-delta)*exp(k(-1)) + ( 1 - phi/2*( exp(i)/exp(i(-1)) -1)^2   )*exp(i);
%exp(k(1)) = (1-delta)*exp(k) + ( 1 - phi/2*( exp(i)/exp(i(-1)) -1)^2   )*exp(i);

%15
%-exp(lambda)*pi(1) + betta*exp(lambda(1))*r = 0;
%-exp(lambda) * re * pi_f(1) + betta * exp(lambda(1)) * re(1) * r_f = 0;
re(1)=r(1)/r_f(1)*pi_f(1)/pi(1)*re;

%16
exp(-sigma * c) - exp(lambda) = 0;

%17
-exp(eta) + betta * exp(lambda(1)) * rk(1) + betta * exp(eta(1)) * (1-delta) = 0;

%18
-exp(lambda) + exp(eta) * ( 1 - phi / 2 * ( exp(i) / exp(i(-1)) -1 )^2 ) - exp(eta) * phi * ( exp(i) / exp(i(-1)) - 1 ) * exp(i) / exp(i(-1)) + betta * exp(eta(1)) * phi * ( exp(i(1)) / exp(i) - 1 ) * ( exp(i(1)) / exp(i) )^2 = 0;

%19
exp(c) + exp(i) = pd * exp(yd) + px * re * exp(yf);

%20
( nua * pd^(1-mua) + (1-nua) * pm^(1-mua) )^( 1 / ( 1 - mua ) ) = 1;

%21
py = ( nuy * pd^(1-muy) + (1-nuy) * (re * px)^(1-muy) )^( 1 / ( 1 - muy ) );

%22-26
exp(da) = exp(lambda) * pd * exp(yd) + dd * betta * ( pid_ss^(1-gammad) * pid^gammad / pid(1) )^(-1/nud) * exp(da(1));
exp(db) = (1+nud) * exp(lambda) * exp(mc) * exp(yd) + dd * betta * ( pid_ss^(1-gammad) * pid^gammad / pid(1) )^(-(1+nud)/nud) * exp(db(1));
pid_star = exp(db) / exp(da) * pid;
pid = ( (1-dd) * pid_star^(-1/nud) + dd * ( pid_ss^(1-gammad) * pid(-1)^gammad )^(-1/nud) )^(-nud);
pd = pid / pi * pd(-1);

%27-31
exp(fa) = exp(lambda) * re * px * exp(yf) + dx * betta * ( pix_ss^(1-gammax) * pix^gammax / pix(1) )^(-1/nux) * exp(fa(1));
exp(fb) = (1+nux) * exp(lambda) * exp(mcf) * exp(yf) + dx * betta * ( pix_ss^(1-gammax) * pix^gammax / pix(1) )^(-(1+nux)/nux) * exp(fb(1));
pix_star = exp(fb) / exp(fa) * pix;
pix = ( (1-dx) * pix_star^(-1/nux) + dx * ( pix_ss^(1-gammax) * pix(-1)^gammax )^(-1/nux) )^(-nux);
px = pix / pi_f * px(-1);

%32-36
exp(qa) = exp(lambda) * pm * exp(qm) + dm * betta * ( pim_ss^(1-gammam) * pim^gammam / pim(1) )^(-1/num) * exp(qa(1));
exp(qb) = (1+num) * exp(lambda) * re * exp(qm) + dm * betta * ( pim_ss^(1-gammam) * pim^gammam / pim(1) )^(-(1+num)/num) * exp(qb(1));
pim_star = exp(qb) / exp(qa) * pim;
pim = ( (1-dm) * pim_star^(-1/num) + dm * ( pim_ss^(1-gammam) * pim(-1)^gammam )^(-1/num) )^(-num);
pm = pim / pi * pm(-1);

%37
exp(qm) = (1-nua) * pm^(-mua) * ( exp(c) + exp(i) );

%38
exp(yd) = nua * pd^(-mua) * ( exp(c) + exp(i) );

%39-40
exp(qx) = (1-nua_f) * px^(-mua_f) * exp(a_f);
exp(yf) = sf * re * exp(qx);

%41
r = r_ss^(1-phim) * r(-1)^phim * ( pi / pi_ss )^( (1-phim) * phipi ) * ( exp(y) / exp(y_ss) )^( (1-phim) * phiy ) * exp(epsilonm);

%42
a_f = rhoa_f * a_f(-1) + ( 1 - rhoa_f ) * a_f_ss + epsilona_f;

%43
r_f = r_f_ss^(1-rhor_f) * r_f(-1)^rhor_f * exp(epsilonr_f);

%44
pi_f = pi_f_ss^(1-rhopi_f) * pi_f(-1)^rhopi_f * exp(epsilonpi_f);

%45
exp(y) = ( nuy^(1/muy) * exp(yd)^( (muy-1) / muy ) + (1-nuy)^(1/muy) * exp(yf)^( (muy-1) / muy ) )^( muy / ( muy - 1 ) );

end;



steady_state_model;
zt              = zt_ss;
sd              = 1;
sf              = 1;
pd              = 1;
pm              = 1;
pi              = 1;
pi_f            = 1;
re              = 1 / ( 1 + num );
%re              = 1 ;
px              = 1 / re;
rk              = ( 1 - betta * ( 1 - delta ) ) / betta;
py              = 1;
pid_star        = 1;
pid             = 1;
pix_star        = 1;
pix             = 1;
pim_star        = 1;
pim             = 1;
r               = 1 / betta;
r_f             = r;
mc              = log( 1 / ( 1 + nud ) );
mcf             = log( 1 / ( 1 + nux ) );
ztf             = log(exp(zt)*exp(mc)/exp(mcf));
w               = log( ( ( ( exp(mc) * exp(zt_ss) )^( 1 - xi ) - alfa * rk^( 1 - xi ) )/( 1 - alfa ) )^( 1 / ( 1 - xi ) ) );
y               = log( exp(w) ^ ( 1 / ( sigmal + sigma ) ) ) - log( ( ( 1 - alfa )/exp(zt_ss)*(exp(mc)*exp(zt)/exp(w))^xi*nuy + ( 1 - alfa )/exp(ztf_ss)*(exp(mcf)*exp(ztf)/exp(w))^xi*( 1 - nuy ) )^( sigmal / ( sigmal + sigma ) ) ) - log( ( 1 - delta * alfa/exp(zt_ss)*(exp(mc)*exp(zt)/rk)^xi*nuy - delta * alfa/exp(ztf_ss)*(exp(mcf)*exp(ztf)/rk)^xi*(1-nuy) )^( sigma / (sigmal + sigma) ) );
%a_f             = log((1-nuy)/(1-nua_f)*(1+num)) + y;
a_f             = log((1-nuy)/(1-nua_f)*(1+num)^(1+mua_f)) + y;
qx              = log( (1 - nua_f)  * px^(-mua_f) ) + a_f;
yd              = log(nuy * exp(y));
yf              = log((1-nuy) * exp(y));
l               = log( (1-alfa)/exp(zt_ss)*(exp(mc)*exp(zt)/exp(w))^xi*nuy + (1-alfa)/exp(ztf_ss)*(exp(mcf)*exp(ztf)/exp(w))^xi*(1-nuy) ) + y;
k               = log( alfa/exp(zt_ss)*(exp(mc)*exp(zt)/rk)^xi*nuy + alfa/exp(ztf_ss)*(exp(mcf)*exp(ztf)/rk)^xi*(1-nuy) ) + y;
i               = log(delta) + k;
c               = log(exp(y)-exp(i));
lambda          = log(exp(c)^(-sigma));
da              = log( exp(lambda) * nuy / ( 1 - dd * betta ) ) + y;
db              = log( (1+nud) * exp(lambda) * nuy / ( 1 - dd * betta ) ) + mc + y;
fa              = log( exp(lambda) * (1 - nuy) / ( 1 - dx * betta ) ) + y;
fb              = log( (1+nux) * exp(lambda) * (1 - nuy) / ( 1 - dx * betta ) ) + mcf + y;
qa              = log( exp(lambda) * (1 - nua) / ( 1 - dm * betta ) ) + y;
qb              = log( (1+num) * exp(lambda) * re * (1 - nua) / ( 1 - dm * betta ) ) + y;
%qb              = log( exp(lambda) * re * (1 - nua) / ( 1 - dm * betta ) ) + y;
qm              = log(1-nua) + y ;
ld              = log( (1-alfa)/exp(zt_ss) * (exp(mc)*exp(zt)/exp(w))^xi ) + yd;
lf              = log( (1-alfa)/exp(ztf_ss) * (exp(mcf)*exp(ztf)/exp(w))^xi ) + yf;
kd              = log( alfa/exp(zt_ss) * (exp(mc)*exp(zt)/rk)^xi ) + yd;
kf              = log( alfa/exp(ztf_ss) * (exp(mcf)*exp(ztf)/rk)^xi ) + yf;
eta             = lambda;

end;

resid;
steady;
check;

shocks;
var epsilonzt    = 0.078;
var epsilonztf   = 0.12;
var epsilona_f   = 0.081;
%var epsilonr_f   = 0.019;
%var epsilonpi_f  = 0.0033;      
end;

stoch_simul(periods=1000,irf=50,order=1) y c l i r ;

estimated_params;  
    stderr epsilonr_f, inv_gamma_pdf,0.01,inf;
    stderr epsilonpi_f, inv_gamma_pdf,0.001,inf;
phipi, gamma_pdf, 2, 1^0.5;  
end;

estimated_params_bounds;
stderr epsilonr_f, 0.001, 0.1;
stderr epsilonpi_f, 0.0001, 0.01;
phipi,  0, 20;
end;

estimated_params_init;   
stderr epsilonr_f, 0.019;
stderr epsilonpi_f, 0.0033;
 phipi               , 1.31;
end;
% Declare observable variables
varobs pi pi_f r_f; 

close all;
 
estimation(datafile=dataforBest,conf_sig =.95,smoother,moments_varendo,filtered_vars,forecast =40,nobs=80,mode_check,mode_compute=4,mh_replic=5000,mh_jscale=1.4,mh_nblocks=2) y r;

